﻿
// ブラウザー判定
var getBrowser = function(){
	var ua = window.navigator.userAgent.toLowerCase();
	var ver = window.navigator.appVersion.toLowerCase();
	var name = 'unknown';

	if (ua.indexOf("msie") != -1){
		if (ver.indexOf("msie 6.") != -1){
			name = 'ie6';
		}else if (ver.indexOf("msie 7.") != -1){
			name = 'ie7';
		}else if (ver.indexOf("msie 8.") != -1){
			name = 'ie8';
		}else if (ver.indexOf("msie 9.") != -1){
			name = 'ie9';
		}else if (ver.indexOf("msie 10.") != -1){
			name = 'ie10';
		}else{
			name = 'ie';
		}
	}else if(ua.indexOf('trident/7') != -1){
		name = 'ie11';
	}else if (ua.indexOf('ipad') != -1){
		name = 'ipad';
	}else if (ua.indexOf('ipod') != -1){
		name = 'ipod';
	}else if (ua.indexOf('iphone') != -1){
		name = 'iphone';
	}else if (ua.indexOf('android') != -1){
		name = 'android';
	}else if (ua.indexOf('mobile') != -1){
		name = 'mobile';
	}else if (ua.indexOf('chrome') != -1){
		name = 'chrome';
	}else if (ua.indexOf('safari') != -1){
		name = 'safari';
	}else if (ua.indexOf('opera') != -1){
		name = 'opera';
	}else if (ua.indexOf('firefox') != -1){
		name = 'firefox';
	};
	return name;
};

// サポート対象のブラウザかチェックして対象外の場合は警告メッセージを表示
function checkSupportedBrowser() {
	if(!isSupportedBrowser()){
		outNoty("warning", "top", "<div class='align-center'>ご利用のブラウザは動作対象外の為、正常に動作しない可能性があります。</div>");
	}
}

// サポート対象のブラウザであるか
function isSupportedBrowser() {
	var ua = window.navigator.userAgent.toLowerCase();

	// iPhone、iPad
	if(/iphone|ipad/.test(ua)){
		// Safariのみ許可
		return (/safari/.test(ua) && /version\//.test(ua));
	}

	// Android
	if(/android/.test(ua)){
		// Chromeのみ許可
		return (/chrome/.test(ua));
	}

	// OSがWindows、Mac以外はサポート対象外
	if(!/windows/.test(ua) && !/macintosh/.test(ua)){
		return false;
	}

	// IE
	if(/msie/.test(ua)){
		var ver = window.navigator.appVersion.toLowerCase();

		// IE10より過去バージョンはサポート対象外
		if(!/msie 10\./.test(ver)){
			return false;
		}

		var nowDate = new Date(Date.now());
		var limitDate = new Date(2019, 0, 1, 0, 0, 0);

		// 2019/1/1以降「IE10」はサポート対象外
		if(nowDate.getTime() < limitDate.getTime()){
			return true;
		}
		return false;
	}

	// IE11/ Edge / Chrome / Safari / Firefox 
	return (/trident\/7|edge|chrome|safari|firefox/.test(ua)); 
}

// チャットウィジェットの表示
var showChatWidget = function(){

	$.ajax({
		type: "get",
		url: collaboflow.page.uri + "&fuseaction=clz_checkZendeskUser",
		cache : false
	}).done(function(result){
		var stResult = JSON.parse(result);
		if(!stResult.ENABLE){
			return;
		}

		/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(c){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","collaboflow.zendesk.com");
		/*]]>*/

		zE(function() {
			$zopim(function(){
				if(stResult.USERNAME.length && stResult.EMAIL.length){
					$zopim.livechat.setName(stResult.USERNAME);
					$zopim.livechat.setEmail(stResult.EMAIL);
				}
			});
		});
	});
};

// プログレスバーを画面中央に表示
function outProgressBar(message) {

	var loadingOverlay = document.getElementById('loading-overlay');
	if (!loadingOverlay || loadingOverlay.style.display === 'block') {
		return;
	}
	loadingOverlay.style.display = 'block';

	var loadingBox = document.getElementById('loading-box');

	var loadingMessage = loadingBox.querySelector('span');
	if (loadingMessage) {
		var loadingText = ( message !== undefined && message.length ) ? message : '読み込み中';
		loadingMessage.innerText = loadingText + "・・・";
	}

	loadingBox.style.display = 'block';
}

// プログレスバーを隠す
function hideProgressBar() {

	var loadingOverlay = document.getElementById('loading-overlay');
	if (!loadingOverlay || loadingOverlay.style.display === 'none') {
		return;
	}
	loadingOverlay.style.display = 'none';

	var loadingBox = document.getElementById('loading-box');
	if (loadingBox) {
		loadingBox.style.display = 'none';
	}
}

// 申請書ウィンドウの表示
var openDocumentWindow = function(url, windowName){
	var width  = screen.availWidth  * 0.8;
	var height = screen.availHeight * 0.85;

	return window.open(url, windowName, "width=" + width + ", height=" + height + ", resizable=yes, menubar=no, toolbar=no, scrollbars=yes, status=yes, top=20, left=20");
};

// 通知の表示
function outNoty(type, layout, text, confirmCallback, argConfirm, afterCloseCallback){

	Noty.closeAll();

	if ( type !== "confirm" ) {

		var notyProperties = { type: type, layout: layout, text: text, theme: 'relax', progressBar: false, 
								closeWith: ['click'], animation: {open:null, close:null}, };
		notyProperties.timeout = (type === "success") ? 2500 : 5000;

		return new Noty(notyProperties).on('afterClose', afterCloseCallback).show();
	}

	var primaryButtonText = '<i class="fa fa-check right5 green"></i>OK';
	if(argConfirm === 'delete') {
		primaryButtonText = '<i class="fa fa-trash right5 red"></i>削除する';
	}

	var n = new Noty(
			{ layout: layout, text: text, theme: 'relax', closeWith:[], animation: { open:null, close:null }, modal: true,
				buttons: [
					Noty.button(primaryButtonText, 'btn btn-primary', function() {
						n.close();
						if ( confirmCallback !== undefined ) {
							confirmCallback(argConfirm); 
						}
					}),
					Noty.button('<i class="fa fa-times right5 red"></i>キャンセル', 'btn btn-danger', function() {
						n.close();
					})
				]
			}).on('afterClose', afterCloseCallback).show();
}

// ファイル準備中ダイアログ
function showOutputFileProgressDialog(message, title) {
	if(!title) {
		title = 'ファイル準備中';
	}

	if(!message) {
		message = 'ファイルを準備しています。\n準備が完了すると出力ファイル一覧からダウンロードできます。';
	}

	// ダイアログの実体は1つのみ
	var $dialog = $('#dialog-outputfile-progress');
	if(!$dialog.length) {
		$dialog = $('<div id="dialog-outputfile-progress"></div>');
	}

	if(typeof message === 'object') {
		$dialog.empty().append(message);
	} else {
		$dialog.html(message.replace(/\n/g, '<br>'));
	}

	$dialog.dialog({
		modal: true,
		width: 600,
		closeText: '',
		title: title,
		buttons: {
			'出力ファイル一覧を開く': function() {
				$(this).dialog('close');
				window.location.href = collaboflow.page.uri + '&fuseaction=clz_OutputFileList';
			},
			'閉じる': function() {
				$(this).dialog('close');
			}
		}
	});
}

// startsWith()ポリフィル
if (!String.prototype.startsWith) {
	Object.defineProperty(String.prototype, 'startsWith', {
		value: function(search, pos) {
			pos = !pos || pos < 0 ? 0 : +pos;
			return this.substring(pos, pos + search.length) === search;
		}
	});
}